# script to register an API

import requests


class Application:
    def __init__(self, base_url, name):
        self.base_url = base_url
        self.name = name
        self.headers = {"Content-Type": "application/json"}

    def register_app(self):
        response = requests.post(
            f"{self.base_url}/api/v1/statuses",
            data={
                "client_name": self.name,
                "redirect_uris": "urn:ietf:wg:oauth:2.0:oob",
                "scopes": "write",
            },
            headers=self.headers,
        )
        response.raise_for_status()
        json_r = response.json()
        self.client_id = json_r["client_id"]
        self.client_secret = json_r["client_secret"]
        print(f"Registered {self.name} as {self.client_id}")


# curl \
#   -X POST \
#   -H 'Content-Type:application/json' \
#   -d '{
#         "client_name": "your_app_name",
#         "redirect_uris": "urn:ietf:wg:oauth:2.0:oob",
#         "scopes": "read"
#       }' \
#   'https://example.org/api/v1/apps'
